#include "Arduino.h"
#include "povbarteensy.h"
#include "MatrixFont.h"

povbarteensy::povbarteensy(byte sData,byte sLatch,byte sClock,byte matrises)
{
	pinMode(sData,OUTPUT);
		pinMode(sLatch,OUTPUT);
	pinMode(sClock,OUTPUT);
	_sData=sData;
	_sLatch=sLatch;
	_sClock=sClock;
	_matrises=matrises;
}


void povbarteensy::povbarteensyDraw() //draw loop,DON'T TOUCH!
{
  setcolumn(_displayPointer);            //column scanning
  setsData(_buffer1[_displayPointer]);    //bit banging shift registers
  digitalWriteFast(_sLatch, LOW);
  digitalWriteFast(_sLatch, HIGH);


}



void povbarteensy::setcolumn(byte col)         //loop that takes care of column scanning DON'T TOUCH!
{
  for (_pos = _matrises*8; _pos > -1; _pos--)
  {
    if (col == _pos)
    {
      digitalWriteFast(_sData, HIGH);
    }
    else
    {
      digitalWriteFast(_sData, LOW);

    }
    digitalWriteFast(_sClock, HIGH);
    digitalWriteFast(_sClock, LOW);

  }
}


void povbarteensy::setsData(byte dat)
{
  for (_pos = 0; _pos < 8; _pos++)
  {
    if (dat & 128)
    {
      dat -= 128;
      digitalWriteFast(_sData, HIGH);

    }
    else
    {
      digitalWriteFast(_sData, LOW);

    }
    dat = dat << 1;  //dat <<1==dat *2;
    digitalWriteFast(_sClock, HIGH);
    digitalWriteFast(_sClock, LOW);

  }
}




void povbarteensy::povbarteensyClr()                          //clear display buffer
{
  for (_addr = 0; _addr < _matrises*8; _addr++) // Empty display buffer
    _buffer1[_addr] = 0;
}

void povbarteensy::povbarteensyPixel(signed char x, signed char y, byte cond)
{
  if (x < 0 || y < 0)
  {
    return; // outside drawing limits negative
  }
  if (x > _matrises*8-1 || y > 7)
  {
    return; // outside drawing limits positive, x=32, y=8
  }
  _pix = _power[y];
  _msk = _buffer1[x]; // get exsisting sData


  if (cond == 2)
    _pix ^= _msk; //XOR sData to screen
  if (cond == 1)
  {
    _pix = ~_pix;
    _pix &= _msk; // AND sData to screen
  }
  if (cond == 0)
    _pix |= _msk; // OR sData to screen
  _buffer1[x] = _pix; // apply changes
}




void povbarteensy::povbarteensyValue(char ch, signed char x, signed char y, byte rotation)
{

  for ( _x1 = 0; _x1 < 8; _x1++)
  {
    _disp = matrixFont[_x1 + (ch << 3)];
    for (_y1 = 0; _y1 < 8; _y1++)
    {
      _disp2 = _disp & _power[_y1];
      if (_disp2 > 0)
      {
        if (rotation == 0)
        {
          povbarteensyPixel(x + _x1, y + _y1, 0); //0 degrees
        }
        if (rotation == 1)
        {
          povbarteensyPixel(7 - (y + _y1), (x + _x1), 0); //90 degrees, flip to left
        }
        if (rotation == 2)
        {
          povbarteensyPixel(7 - (x + _x1), 7 - (y + _y1), 0);
        }
        if (rotation == 3)
        {
          povbarteensyPixel(y + _y1, 7 - (x + _x1), 0); //90 degrees, flip to right
        }
      }
    }
  }
}





void povbarteensy::povbarteensyText(char* ch, signed char x, signed char y, byte rotation)  //strput relies on charput
{
  while (*ch )
  {
    povbarteensyValue(*ch++, x, y, rotation); //write a string to the display buffer
    x += 7;
  }
}
