#include <povbarteensy.h>
#include <MatrixFont.h>

#include <FontMap7Segment.h>
#include <_74595_sevenSegment_teensy.h>


povbarteensy m(10, 8, 7, 1);
sevenSegment s(10, 8, 7, 4);

#define HWSERIAL Serial1

char receivedText[40]; //array to store incoming data
char character;
byte receivedTextPointer;
byte textLength; //for dynaminc scroll length
long bartime;

void setup()
{
  HWSERIAL.begin(9600);
  Serial.begin(9600);
  delay(1000); //small delay to ignore garbage from serial

  while (millis() < 30000)  //show ip for 30 seconds from boot
  {
    readESP();
    s.sevenSegmentClr();
    s.sevenSegmentText(receivedText, 4 - millis() / 250 % 20, 0);
    s.sevenSegmentDraw();
    m.povbarteensyClr();
    m.povbarteensyDraw();
  }

  for (byte i = 0; i < 40; i++)
  {
    receivedText[i] = 0;
  }

  m.povbarteensyClr();
  m.povbarteensyDraw();
  s.sevenSegmentClr();
  s.sevenSegmentDraw();
}

void loop()
{
  readESP();
  bartime = map(analogRead(A0), 0, 1023, 500, 5000);

  m.povbarteensyClr();
  m.povbarteensyText(receivedText, 0 - micros() / bartime % 40, 0, 0);
  m.povbarteensyDraw();

  s.sevenSegmentClr();
  s.sevenSegmentText(receivedText, 4 - millis() / 250 % 20, 0);
  s.sevenSegmentDraw();
}

void readESP()
{
  if (HWSERIAL.available() > 0)
  {
    character = HWSERIAL.read();

    if ((character != '\r') && (character != '\n')) //Keep these out of our buffer
    {
      receivedText[receivedTextPointer++] = character; //Add whatever we receive to the buffer
    }

    if (character == '\n')   //when we get the terminating character \n
    {
      textLength = receivedTextPointer;
      receivedText[receivedTextPointer++] = '\0';//Converts the array into a string
      receivedTextPointer = 0; //next time we start from beginning index
    }
  }
}

